package com.qmth.sop.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qmth.sop.business.entity.TBSopInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * sop表 Mapper 接口
 * </p>
 *
 * @author wangliang
 * @since 2023-08-01
 */
public interface TBSopInfoMapper extends BaseMapper<TBSopInfo> {

    /**
     * 查询动态sop表名是否存在
     *
     * @param db
     * @param tableName
     * @return
     */
    int selectSopDynamicExist(@Param("db") String db, @Param("tableName") String tableName);

    /**
     * 保存动态sop信息
     *
     * @param tableName
     * @param flowDeploymentId
     * @param flowId
     * @param fieldName
     * @param fieldValue
     * @return
     */
    Boolean saveDynamicSop(@Param("tableName") String tableName, @Param("flowDeploymentId") String flowDeploymentId, @Param("flowId") Long flowId, @Param("fieldName") String fieldName, @Param("fieldValue") List<Map> fieldValue);

    /**
     * 更新动态sop信息
     *
     * @param tableName
     * @param flowId
     * @param fieldName
     * @param fieldValue
     * @return
     */
    Boolean updateDynamicSop(@Param("tableName") String tableName, @Param("flowDeploymentId") String flowDeploymentId, @Param("flowId") Long flowId, @Param("fieldName") String fieldName, @Param("fieldValue") List<Map> fieldValue);

    /**
     * 查询动态sop数据
     *
     * @param tableName
     * @param flowDeploymentId
     * @param flowId
     * @param fieldName
     * @return
     */
    int selectDynamicSop(@Param("tableName") String tableName, @Param("flowDeploymentId") String flowDeploymentId, @Param("flowId") Long flowId, String fieldName);
}
